#ifndef FLYFM_AUTHENTICATOR_H
#define FLYFM_AUTHENTICATOR_H

#include <flyfm/vfs_export.h>

#include <QString>

namespace FlyFM
{

class FLYFM_VFS_EXPORT Authenticator
{
    Q_DISABLE_COPY(Authenticator)
public:
    Authenticator();
    virtual ~Authenticator();

    void setResource(const QString &protocol, const QString &domain, const QString &server, const QString &object);
    QString protocol() const;
    QString domain() const;
    QString server() const;
    QString object() const;

    virtual QString getAuth(bool allowUserInteraction, const QString &authTitle, const QString &authMessage,
                            QString *user, bool *userChanged, bool *cancelled) = 0;
    virtual void clearPassword(const QString &user) = 0;
    virtual void approveLastPassword() = 0;

    virtual bool yesNoQuestion(const QString &title, const QString &question) = 0;

protected:
    QString m_protocol;
    QString m_domain;
    QString m_server;
    QString m_object;
};

}

#endif // FLYFM_AUTHENTICATOR_H
