/*

  Graphic user's interface library
  Control dialog

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMCONTROLDIALOG_H
#define FLYFMCONTROLDIALOG_H

#include <flyfm/gui_export.h>
#include <flyfm/dialog.h>

class Ui_ControlDialog;

namespace FlyFM
{
class UserPropCapsWidget;
class ServiceSettingsWidget;
class GeneralSettingsWidget;

class FLYFM_GUI_EXPORT ControlDialog : public Dialog
{
    Q_OBJECT
public:
    explicit ControlDialog(QWidget *parent = nullptr, bool deleteOnClose = false);
    virtual ~ControlDialog();

signals:
    void closed();

protected slots:
    void slotDone();
    void slotCancel();

protected:
    ::Ui_ControlDialog *m_pUi;

    GeneralSettingsWidget *m_generalSettingsWidget;
    ServiceSettingsWidget *m_serviceSettingsWidget;
    UserPropCapsWidget *m_userPropCapsWidget;

    QWidget *m_generalTabWidget;
};
}

#endif // FLYFMCONTROLDIALOG_H
