#ifndef COREPATHS_H
#define COREPATHS_H

#include <flyfm/core_export.h>

#include <QStringList>

namespace FlyFM
{
FLYFM_CORE_EXPORT QString resolveEnvironmentVariables(const QString &path);
FLYFM_CORE_EXPORT QString mimeTypeForFile(const QString &path, bool det = true);
quint64 totalSize(const QStringList &paths);
FLYFM_CORE_EXPORT QString shortedPathView(const QString &path);
quint64 pathSize(const QString &path);
FLYFM_CORE_EXPORT QString uniqueFileName(const QString &path, const QString &baseName, const QString &ext = QString());
FLYFM_CORE_EXPORT QStringList newFileTemplates();
FLYFM_CORE_EXPORT QString locateFile(const QString &fileName, const QStringList &paths, int depth = 0);
struct FLYFM_CORE_EXPORT PathInfo
{
    QString dir;
    QString name;
};
FLYFM_CORE_EXPORT PathInfo pathForCopy(const QString &path);
}

#endif
