/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_COREPLUGINSMANAGER_H
#define FLYFM_COREPLUGINSMANAGER_H

#include <flyfm/core_export.h>

#include <QHash>

#include <flyfm/singletone.h>

namespace FlyFM
{

class PropsPlugin;

class FLYFM_CORE_EXPORT CorePluginsManager : public Singletone
{
public:
    static CorePluginsManager *ptr();
    virtual ~CorePluginsManager();

    QList<PropsPlugin *> propsPlugins() const;
    QString pluginFileName(PropsPlugin *propsPlugin) const;

    void release() override;

protected:
    CorePluginsManager();

    QList<PropsPlugin *> m_propsPlugins;
    QHash<PropsPlugin *, QString> m_pluginsFileNames;
};

}

#endif // FLYFM_COREPLUGINSMANAGER_H
