/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMDESKTOP_H
#define FLYFMDESKTOP_H

#include <flyfm/core_export.h>
#include <flyfm/entry.h>
#include <flyfm/serviceinterfacesingletone.h>

namespace FlyFM
{

class FLYFM_CORE_EXPORT Desktop : public QObject, public ServiceInterfaceSingletone
{
    Q_OBJECT
public:
    static Desktop *ptr();
    ~Desktop();

    enum WindowOption { NoOptions = 0x00, MountPoint = 0x01, Simple = 0x02, FileActions = 0x04 };
    Q_DECLARE_FLAGS(WindowOptions, WindowOption)
    Q_FLAG(WindowOptions)

    int callDesktop();
    int callControlDialog();
    int callRegularWindow(const Entry &startEntry = Entry(), WindowOptions windowOptions = WindowOptions());

protected:
    Desktop(QObject *parent = nullptr);
    static Desktop *m_ptr;

private:
    QWeakPointer<QDBusInterface> m_interface;
};

}

#endif // FLYFMDESKTOP_H
