#ifndef FLYFMDESKTOPWIDGET_H
#define FLYFMDESKTOPWIDGET_H

#include <QDesktopWidget>
#include <QModelIndexList>

namespace FlyFM
{

class FileActionsProvider;
class DesktopView;
class Entry;
class EntryList;
class Model;

class DesktopWidget : public QDesktopWidget
{
    Q_OBJECT
public:
    DesktopWidget(QWidget *parent = nullptr);
    ~DesktopWidget();

    void setItemGridSnap(bool);
    bool isItemGridSnap() const;
    void arrangeItems();

    EntryList selectedEntries() const;

    Model *model();
    DesktopView *view();

public slots:
    void highlightEntry(const Entry &);

protected slots:
    void dropPopupContextMenu(const QPoint &, Qt::DropActions, const EntryList &, const Entry &);
    void customPopupContextMenu(const QPoint &, const QModelIndexList &);
    void openAction(const QModelIndexList &indexes);

    void doubleClicked(const QModelIndex &index);
    /*void dropPopupContextMenu( const QPoint &, const EntryList &, const Entry & );
    void customPopupContextMenu( const QPoint & );*/

    void updateShortcutFileAction();

protected:
    virtual void openFolderWidget(const Entry &) = 0;
    bool event(QEvent *event) override;

    Model *m_model;
    DesktopView *m_view;
    FileActionsProvider *m_fileActionsProvider;

    friend class PopupMenu;
};
}

#endif // FLYFMDESKTOPWIDGET_H
