#ifndef FLYFMDEVICE_H
#define FLYFMDEVICE_H

#include <QString>
#include <QMetaType>

class QDBusArgument;

namespace FlyFM
{
class Device;
}

QDBusArgument &operator<<(QDBusArgument &arg, const FlyFM::Device &device);
const QDBusArgument &operator>>(const QDBusArgument &arg, FlyFM::Device &device);

namespace FlyFM
{
class Device
{
public:
    enum DeviceType { UndefinedDevice = 0, FloppyDrive = 1, CdromDrive = 2, UsbDisk = 3, HardDisk = 4 };

    Device();
    Device(const Device &device);

    Device &operator=(const Device &device);
    bool operator==(const Device &device) const;

    QString uid() const;
    DeviceType deviceType() const;

protected:
    void toDBusArgument(QDBusArgument &arg) const;
    void fromDBusArgument(const QDBusArgument &arg);

    friend QDBusArgument &::operator<<(QDBusArgument &arg, const Device &device);
    friend const QDBusArgument &::operator>>(const QDBusArgument &arg, Device &device);

    QString m_uid;
    DeviceType m_deviceType;
};
}

Q_DECLARE_METATYPE(FlyFM::Device)

#endif // FLYFMDEVICE_H
