/*

  Graphic user's interface library
  Entry combo box

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMENTRYCOMBOBOX_H
#define FLYFMENTRYCOMBOBOX_H

#include <QComboBox>

namespace FlyFM
{

class Navigation;
class Entry;

class EntryComboBox : public QComboBox
{
    Q_OBJECT
public:
    explicit EntryComboBox(Navigation *pNavigation, QWidget *parent = nullptr);
    ~EntryComboBox();

    void setNavigation(Navigation *pNavigation);

    void showPopup() override;
    void hidePopup() override;

public slots:
    void openAddress();

signals:
    void currentEntryUpdated(const Entry &entry);
    void currentChanged(const Entry &entry);
    void lostFocus();
    void sizeHintChanged();

protected:
    void focusOutEvent(QFocusEvent *e) override;
    void changeEvent(QEvent *e) override;

private slots:
    void entryChanged(const Entry &);
    void slotCurrentChanged(const Entry &);

private:
    void setEntry(const Entry &);

private:
    Navigation *m_pNavigation;
    bool m_popupIsShown;
};

}

#endif // FLYFMENTRYCOMBOBOX_H
