#ifndef FLYFM_ENTRYPROPERTYSET_H
#define FLYFM_ENTRYPROPERTYSET_H

#include <flyfm/core_export.h>

#include <QVariant>
#include <QStringList>

namespace FlyFM
{

class Entry;

class FLYFM_CORE_EXPORT EntryPropertySet
{
public:
    EntryPropertySet();
    EntryPropertySet(const EntryPropertySet &) = delete;
    EntryPropertySet &operator=(const EntryPropertySet &) = delete;
    virtual ~EntryPropertySet();

    virtual void initData(const Entry &entry) = 0;
    virtual QVariant data(const Entry &entry, int index, int role) const = 0;

    virtual bool canRefineData(const Entry &entry) const;
    virtual void refineData(const Entry &entry);

    virtual QStringList emblems(const Entry &entry) const;

    virtual void updatePresentation(const Entry &entry, bool refined);
};

} // namespace FlyFM

#endif // FLYFM_ENTRYPROPERTYSET_H
