#ifndef FAVOURITEPLACE_H
#define FAVOURITEPLACE_H

#include <flyfm/vfs_export.h>

#include <QString>
#include <QList>
#include <QMetaType>

class QDataStream;
class QDBusArgument;

namespace FlyFM
{
class FavouritePlace;
using FavouritePlaceList = QList<FavouritePlace>;
}

QDataStream &operator<<(QDataStream &out, const FlyFM::FavouritePlace &place);
QDataStream &operator>>(QDataStream &in, FlyFM::FavouritePlace &place);

QDBusArgument &operator<<(QDBusArgument &arg, const FlyFM::FavouritePlace &favouritePlace);
const QDBusArgument &operator>>(const QDBusArgument &arg, FlyFM::FavouritePlace &favouritePlace);

namespace FlyFM
{

class FLYFM_VFS_EXPORT FavouritePlace
{
public:
    FavouritePlace();
    FavouritePlace(const QString &name, const QString &localPath);

    bool operator<(const FavouritePlace &place) const;
    bool operator==(const FavouritePlace &place) const;

    QString name() const;
    QString localPath() const
    {
        return m_localPath;
    }

private:
    friend QDataStream &::operator<<(QDataStream &out, const FavouritePlace &place);
    friend QDataStream &::operator>>(QDataStream &in, FavouritePlace &place);

    QDBusArgument &toDBusArgument(QDBusArgument &arg) const;
    const QDBusArgument &fromDBusArgument(const QDBusArgument &arg);

    friend QDBusArgument &::operator<<(QDBusArgument &arg, const FavouritePlace &favouritePlace);
    friend const QDBusArgument &::operator>>(const QDBusArgument &arg, FavouritePlace &favouritePlace);

    QString m_name;
    QString m_localPath;
};

}

Q_DECLARE_METATYPE(FlyFM::FavouritePlace)
Q_DECLARE_METATYPE(FlyFM::FavouritePlaceList)

#endif // FAVOURITEPLACE_H
