#ifndef FLYFM_FAVOURITEPLACESMANAGERPROXY_H
#define FLYFM_FAVOURITEPLACESMANAGERPROXY_H

#include <QObject>
#include <QWeakPointer>
#include <QDBusInterface>

#include <flyfm/favouriteplace.h>

namespace FlyFM
{

class FavouritePlacesManagerProxy : public QObject
{
    Q_OBJECT
public:
    explicit FavouritePlacesManagerProxy(QWeakPointer<QDBusInterface> interface, QObject *parent = nullptr);

    QList<FavouritePlace> favouritePlaces();
    void addFavouritePlace(const FavouritePlace &place);
    void removeFavouritePlace(const FavouritePlace &place);

signals:
    void favouritePlaceAdded(const FlyFM::FavouritePlace &place);
    void favouritePlaceRemoved(const FlyFM::FavouritePlace &place);

private slots:
    void slotFavouritePlaceAdded(const FlyFM::FavouritePlace &place);
    void slotFavouritePlaceRemoved(const FlyFM::FavouritePlace &place);

private:
    QWeakPointer<QDBusInterface> m_interface;
    QList<FavouritePlace> m_places;
    bool m_cached;
};

} // namespace FlyFM

#endif // FLYFM_FAVOURITEPLACESMANAGERPROXY_H
