#ifndef FLYFM_FUSEMOUNTSMANAGERPROXY_H
#define FLYFM_FUSEMOUNTSMANAGERPROXY_H

#include <QObject>
#include <QWeakPointer>

#include <flyfm/stringpair.h>

class QDBusInterface;

namespace FlyFM
{

class FuseMountsManagerProxy : public QObject
{
    Q_OBJECT
public:
    explicit FuseMountsManagerProxy(QWeakPointer<QDBusInterface> interface, QObject *parent = nullptr);

    StringMap mounts() const;

    void addMount(const QString &url, const QString &localPath);

signals:
    void mountAdded(const QString &url, const QString &localPath);

private:
    QWeakPointer<QDBusInterface> m_interface;
};

} // namespace FlyFM

#endif // FLYFM_FUSEMOUNTSMANAGERPROXY_H
