/*

  Explorer Core Library
  Global Variables (must be a config in future)

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMGLOBAL_H
#define FLYFMGLOBAL_H

#include <flyfm/core_export.h>

#include <QStringList>
#include <QRect>
#include <QColor>
#include <QSettings>

namespace FlyFM
{

class FLYFM_CORE_EXPORT Global
{
public:
    enum DesktopImagePlacement { DefaultPlacement = 0, CenterPlacement = 1, StretchedPlacement = 2, TiledPlacement = 3 };

    static Global *ptr();
    virtual ~Global();

    QString startMenuDirPath();
    QString toolbarDirPath();
    QString autostartDirPath();
    QString shareDirPath();
    QString tmpDirPath();

    QString pluginsDirPath() const;
    QString trashTopDirPath();
    QString dataDir();

    QString shellProgram();
    QStringList shellArgs();
    QString terminalProgram();
    QStringList terminalArgs();
    QStringList terminalDependedApplications();

    QString desktopImagePath();
    DesktopImagePlacement desktopImagePlacement();
    QRect desktopGeometry();
    QColor desktopColor();

    QSettings *settings();

private:
    Global();

    QSettings m_settings;

    static Global *m_ptr;
};

}

#endif // FLYFMGLOBAL_H
