#ifndef FLYFM_GUIAUTHENTICATOR_H
#define FLYFM_GUIAUTHENTICATOR_H

#include <flyfm/gui_export.h>

#include <QString>
#include <QMap>
#include <QSet>

#include <flyfm/authenticator.h>

class QWidget;

namespace FlyFM
{

class FLYFM_GUI_EXPORT GuiAuthenticator : public Authenticator
{
public:
    GuiAuthenticator(QWidget *parent);

    QString getAuth(bool allowUserInteraction, const QString &authTitle, const QString &authMessage,
                    QString *user, bool *userChanged, bool *cancelled) override;
    void clearPassword(const QString &user) override;
    void approveLastPassword() override;

    bool yesNoQuestion(const QString &title, const QString &question) override;

private:
    void setAuth(const QString &user, const QString &password);
    void tryGetAuths();

    QWidget *m_parentWidget;

    QString m_lastUser;
    QString m_lastPassword;

    bool m_authsInited;
    QMap<QString, QString> m_auths;
    QSet<QString> m_invalidatedAuths;
};

}

#endif // FLYFM_GUIAUTHENTICATOR_H
