/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_GUIPLUGINSMANAGER_H
#define FLYFM_GUIPLUGINSMANAGER_H

#include <flyfm/gui_export.h>

#include <QList>

#include <flyfm/singletone.h>

namespace FlyFM
{

class ActionPlugin;
class ActionPluginV2;

class FLYFM_GUI_EXPORT GuiPluginsManager : public Singletone
{
public:
    static GuiPluginsManager *ptr();
    virtual ~GuiPluginsManager();

    QList<ActionPlugin *> actionPlugins();
    QList<ActionPluginV2 *> actionPluginsV2();

    void release() override;

protected:
    GuiPluginsManager();

    QList<ActionPlugin *> m_actionPlugins;
    QList<ActionPluginV2 *> m_actionPluginsV2;
};

}

#endif // FLYFM_GUIPLUGINSMANAGER_H
