/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMICONPROVIDER_H
#define FLYFMICONPROVIDER_H

#include <QString>

class QFileInfo;

namespace FlyFM
{
class IconProvider
{
public:
    enum IconContext { Applications, Actions, Devices, Places, Status, MimeTypes, Uncontexted };

    static IconProvider *ptr();

    QString nameForFile(const QString &filePath) const;

protected:
    IconProvider();
    IconProvider(const IconProvider &) = delete;
    IconProvider &operator=(const IconProvider &) = delete;

    QString iconNameForDesktopFile(const QString &desktopPath) const;
    QString iconNameForDir(const QFileInfo &dirInfo) const;
};

}

#endif // FLYFMICONPROVIDER_H
