#ifndef ICONSIZE_H
#define ICONSIZE_H

#include <flyfm/core_export.h>

#include <QString>

class QDataStream;

namespace FlyFM
{

class FLYFM_CORE_EXPORT IconSize
{
public:
    enum Size { Tiny = 16, Small = 22, Medium = 32, Large = 48, VeryLarge = 64, Huge = 128 };
    IconSize();
    IconSize(Size size);
    explicit IconSize(int sz);

    bool canBeIncreased() const;
    bool canBeDecreased() const;
    void increase();
    void decrease();
    int toInt() const;
    QString name() const;

    int sizeIndex() const;
    static QString nameForIndex(int idx);

    static const Size sizes[];
    static const int nSizes;

private:
    Size m_size;
};

}

FLYFM_CORE_EXPORT QDataStream &operator<< (QDataStream &out, const FlyFM::IconSize &iconSize);
FLYFM_CORE_EXPORT QDataStream &operator>> (QDataStream &in, FlyFM::IconSize &iconSize);

#endif
