/*

  Graphic user's interface library
  List view

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_LISTVIEW_H
#define FLYFM_LISTVIEW_H

#include <flyfm/listandiconview.h>
#include <flyfm/scheduledupdateview.h>

namespace FlyFM
{

class ViewSignalsObject;

class ListView : public ListAndIconView
{
    Q_OBJECT

public:
    ListView(ViewSignalsObject *signalsObject, QWidget *parent = nullptr);
};

class ScheduledUpdateListView : public ScheduledUpdateView<ListView>
{
    Q_OBJECT
public:
    explicit ScheduledUpdateListView(ViewSignalsObject *signalsObject, QWidget *parent = nullptr)
        : ScheduledUpdateView<ListView>(signalsObject, parent)
    {}

protected:
    void callDataChanged(const QModelIndex &topLeft, const QModelIndex &bottomRight,
                         const QVector<int> &roles) override
    {
        ListView::dataChanged(topLeft, bottomRight, roles);
    }
};

}

#endif
