#ifndef FLYFM_LOCATIONBAR_H
#define FLYFM_LOCATIONBAR_H

#include <flyfm/gui_export.h>

#include <QWidget>

class QHBoxLayout;
class QCompleter;

namespace FlyFM
{

class PathButtonsBar;
class EntryComboBox;
class Navigation;
class Entry;

class FLYFM_GUI_EXPORT LocationBar : public QWidget
{
    Q_OBJECT
public:
    explicit LocationBar(Navigation *pNavigation, QWidget *parent = nullptr);

    void setNavigation(Navigation *pNavigation);
    void setCompleter(QCompleter *completer);
    void setRootEntry(const Entry &root);

    QSize minimumSizeHint() const override;

public slots:
    void openAddress();

signals:
    void currentEntryUpdated(const Entry &entry);
    void currentChanged(const Entry &entry);
    void pathEdited(const QString &path);

private slots:
    void setEditModeEnabled();
    void setEditModeDisabled();
    void recomputeWidgetsHeights();

private:
    QHBoxLayout *m_layout;
    PathButtonsBar *m_buttonsBar;
    EntryComboBox *m_entryComboBox;
};

} // namespace FlyFM

#endif // FLYFM_LOCATIONBAR_H
