/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMMIMEAPPS_H
#define FLYFMMIMEAPPS_H

#include <QObject>

#include <flyfm/core_export.h>
#include <flyfm/appinfo.h>
#include <flyfm/serviceinterfacesingletone.h>

class QDBusInterface;

namespace FlyFM
{

class FLYFM_CORE_EXPORT MimeApps : public QObject, public ServiceInterfaceSingletone
{
    Q_OBJECT
public:
    static MimeApps *ptr();
    static void freePtr();
    ~MimeApps();

    AppInfoList allRegisteredApplications();

    AppInfoList mimeTypeApplications(const QString &mimeType);
    void setAppsForMime(const QString &mimeType, const AppInfoList &apps);

    bool setDefaultApplication(AppInfo appInfo);

    void setDefaultMimeTypeApplication(const QString &mimeType, AppInfo appInfo);
    AppInfo defaultMimeTypeApplication(const QString &mimeType);

    void setDefaultWebBrowserExec(const QString &exec);
    QString defaultWebBrowserExec();

    void setDefaultMailClientExec(const QString &exec);
    QString defaultMailClientExec();

    void setDefaultMailSenderExec(const QString &exec);
    QString defaultMailSenderExec();

    void callDialog();

protected:
    MimeApps();

private:
    static MimeApps *m_ptr;

    QWeakPointer<QDBusInterface> m_interface;
};

}

#endif // FLYFMMIMEAPPS_H
