#ifndef FLYFM_MOUNTFUSEENTRYJOB_H
#define FLYFM_MOUNTFUSEENTRYJOB_H

#include <QSharedPointer>

#include <flyfm/job.h>

namespace FlyFM
{

class Entry;
class Authenticator;

class FLYFM_VFS_EXPORT MountFuseEntryJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, InternalError, NotInFuseGroup };

    explicit MountFuseEntryJob(QSharedPointer<Authenticator> authenticator, const QString &urlStr, QObject *parent);

    void start() override;

    QString path() const;

private slots:
    void slotMountUrlFinished(Job *job);
    void slotFuseMountAdded(const QString &urlStr, const Entry &entry);

private:
    bool checkMountExists(const QString &url);
    void updatePath();

    QString m_urlStr;
    QString m_localPath;
    QString m_path;
    QSharedPointer<Authenticator> m_authenticator;
    QString m_mountUrl;
};

} // namespace FlyFM

#endif // FLYFM_MOUNTFUSEENTRYJOB_H
