#ifndef FLYFM_MOUNTSMBURLJOB_H
#define FLYFM_MOUNTSMBURLJOB_H

#include <QString>
#include <QSharedPointer>

#include <flyfm/job.h>

namespace FlyFM
{

class Authenticator;

class MountSmbURLJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NotSambaEntry, LoginCancelled, NoShareEntry, NotInFuseGroup, InternalError };

    explicit MountSmbURLJob(QSharedPointer<Authenticator> authenticator, const QString &url, QObject *parent = nullptr);

    void start() override;

    QString url() const;
    QString localPath() const;

private slots:
    void checkSmbAuthJobFinished(Job *job);

private:
    QString m_url;
    QSharedPointer<Authenticator> m_authenticator;
    QString m_tailPath;
    QString m_localPath;
};

} // namespace FlyFM

#endif // FLYFM_MOUNTSMBURLJOB_H
