#ifndef FLYFM_MOUNTURLJOB_H
#define FLYFM_MOUNTURLJOB_H

#include <QString>
#include <QSharedPointer>

#include <flyfm/job.h>

namespace FlyFM
{

class Authenticator;

class FLYFM_VFS_EXPORT MountURLJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NotSambaEntry, LoginCancelled, NoShareEntry, NotInFuseGroup, InternalError };

    explicit MountURLJob(QSharedPointer<Authenticator> authenticator, const QString &url, QObject *parent = nullptr);
    ~MountURLJob();

    void start() override;

    QString url() const;
    QString localPath() const;

private:
    QString m_url;
    QSharedPointer<Authenticator> m_authenticator;
    QString m_localPath;
};

} // namespace FlyFM

#endif // FLYFM_MOUNTURLJOB_H
