#ifndef FLYFM_NETWORKMOUNTSMANAGERPROXY_H
#define FLYFM_NETWORKMOUNTSMANAGERPROXY_H

#include <QObject>
#include <QWeakPointer>

#include <flyfm/stringpair.h>

class QDBusInterface;

namespace FlyFM
{

class NetworkMountsManagerProxy : public QObject
{
    Q_OBJECT
public:
    explicit NetworkMountsManagerProxy(QWeakPointer<QDBusInterface> interface, QObject *parent = nullptr);

    StringEntryMap mounts() const;

    void addMount(const QString &url, const FlyFM::Entry &entry);

signals:
    void mountAdded(const QString &url, const FlyFM::Entry &entry);

private:
    QWeakPointer<QDBusInterface> m_interface;
};

} // namespace FlyFM

#endif // FLYFM_NETWORKMOUNTSMANAGERPROXY_H
