/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_OPEN_H
#define FLYFM_OPEN_H

#include <flyfm/core_export.h>
#include <flyfm/serviceinterfacesingletone.h>

namespace FlyFM
{

class Entry;
class EntryList;

class FLYFM_CORE_EXPORT Open : public ServiceInterfaceSingletone
{
public:
    static Open *ptr();
    ~Open();

    bool isAvailable() const;
    void open(const EntryList &entries, bool dialog = false, const QString &workingDir = QString());
    bool canOpen(const Entry &entry);

    static bool shouldOpenAsUser();

protected:
    Open();

private:
    static Open *m_ptr;

    bool m_available;
    QWeakPointer<QDBusInterface> m_interface;
};

}

#endif // FLYFMOPEN_H
