/*

  Graphic user's interface library
  Permission set widget

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMPERMSETWIDGET_H
#define FLYFMPERMSETWIDGET_H

#include <flyfm/gui_export.h>

#include <QWidget>

namespace FlyFM
{
class PermCheckBox;

class FLYFM_GUI_EXPORT PermsetWidget : public QWidget
{
    Q_OBJECT
public:
    enum ViewMode { TextMode = 0, PixmapMode = 1 };

    explicit PermsetWidget(ViewMode viewMode = TextMode, QWidget *parent = nullptr, int value = 0);
    ~PermsetWidget();

    int value() const;

    static int minimumSizeForPixmapMode();

signals:
    void changed();

public slots:
    void setValue(int value);
    void setMask(int mask);

protected:
    PermCheckBox *m_pCBRead;
    PermCheckBox *m_pCBWrite;
    PermCheckBox *m_pCBExec;
    int m_mask;
};
}

#endif // FLYFMPERMSETWIDGET_H
