#ifndef PROCESSINFO_H
#define PROCESSINFO_H

#include <QMetaType>
#include <QString>

class QDBusArgument;

namespace FlyFM
{
class ProcessInfo;
}

QDBusArgument &operator<<(QDBusArgument &arg, const FlyFM::ProcessInfo &procInfo);
const QDBusArgument &operator>>(const QDBusArgument &arg, FlyFM::ProcessInfo &procInfo);

namespace FlyFM
{

class ProcessInfo
{
    friend QDBusArgument &::operator<<(QDBusArgument &arg, const ProcessInfo &procInfo);
    friend const QDBusArgument &::operator>>(const QDBusArgument &arg, ProcessInfo &procInfo);
public:
    explicit ProcessInfo(int pid = -1, const QString &name = QString(), const QString &cmd = QString());

    int pid() const
    {
        return m_pid;
    }
    void setPid(int pid)
    {
        m_pid = pid;
    }

    QString name() const
    {
        return m_name;
    }
    void setName(const QString &name)
    {
        m_name = name;
    }

    QString command() const
    {
        return m_command;
    }
    void setCommand(const QString &command)
    {
        m_command = command;
    }

private:
    int m_pid;
    QString m_name;
    QString m_command;
};

using ProcessInfoList = QList<ProcessInfo>;

}

#if !defined(QT_NO_DEBUG_STREAM)
QDebug operator<<(QDebug, const FlyFM::ProcessInfo &);
#endif

Q_DECLARE_METATYPE(FlyFM::ProcessInfo)
Q_DECLARE_METATYPE(FlyFM::ProcessInfoList)

#endif
