/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMPROPSDIALOG_H
#define FLYFMPROPSDIALOG_H

#include <flyfm/gui_export.h>
#include <flyfm/entrylist.h>
#include <flyfm/dialog.h>

class Ui_PropsDialog;

namespace FlyFM
{

class PropsPluginWidget;

class FLYFM_GUI_EXPORT PropsDialog : public Dialog
{
    Q_OBJECT
public:
    explicit PropsDialog(const EntryList &entries, QWidget *parent = nullptr);
    virtual ~PropsDialog();

    EntryList entries() const;

protected:
    void changeEvent(QEvent *) override;

protected slots:
    void pbOkClicked();
    void pbCancelClicked();

    void slotNameEdited(const QString &name);

private:
    void loadSettings();
    void saveSettings() const;

    void updatePixelMetricForIconLabel();
    void onPluginWidgetChanged(PropsPluginWidget *widget);

    EntryList m_entries;
    QString m_initialEntryName;
    QVector<PropsPluginWidget *> m_changedWidgets;

    ::Ui_PropsDialog *m_pUi;
};
}

#endif // FLYFMPROPSDIALOG_H
