/*

  Explorer Graphic User's Interface Library
  Refresh action

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMREFRESHACTION_H
#define FLYFMREFRESHACTION_H

#include <flyfm/gui_export.h>

#include <QObject>

class QAction;
class QToolBar;
class QMenu;

namespace FlyFM
{
class Navigation;
class Job;

class FLYFM_GUI_EXPORT RefreshAction : public QObject
{
    Q_OBJECT
public:
    explicit RefreshAction(Navigation *pNavigation, QObject *parent = nullptr);
    ~RefreshAction();

    void addToToolBar(QToolBar *pToolBar);
    void addToMenu(QMenu *pMenu);

    QAction *getQAction()
    {
        return m_pARefresh;
    }

    void setNavigation(Navigation *navigation);

signals:
    void activated();

protected slots:
    void refreshActionActivated();
    void updateSmbEntryJobFinished(Job *job);
    void updateNetworkPlaceJobFinished(Job *job);

protected:
    QAction *m_pARefresh;
    Navigation *m_navigation;
};
}

#endif // FLYFMREFRESHACTION_H
