#ifndef FLYFMSERVICEINTERFACESINGLETONE_H
#define FLYFMSERVICEINTERFACESINGLETONE_H

#include <flyfm/core_export.h>

#include <QString>
#include <QSharedPointer>
#include <QScopedPointer>
#include <QList>

#include <flyfm/singletone.h>

class QDBusInterface;

namespace FlyFM
{

class FLYFM_CORE_EXPORT ServiceInterfaceSingletone : public Singletone
{
public:
    ServiceInterfaceSingletone(const QString &service);
    virtual ~ServiceInterfaceSingletone();

    bool isAvailable() const;

    QWeakPointer<QDBusInterface> createInterface(const QString &path, const QString &interface);

    void release() override;

private:
    QString m_service;
    QList<QSharedPointer<QDBusInterface>> m_interfaces;
    QScopedPointer<QDBusInterface> m_serviceInterface;
};

}

#endif // FLYFMINTERFACESINGLETONE_H
