#ifndef FLYFM_SMBURL_H
#define FLYFM_SMBURL_H

#include <flyfm/vfs_export.h>

#include <QString>

namespace FlyFM
{

class FLYFM_VFS_EXPORT SmbUrl
{
public:
    explicit SmbUrl(const QString &url = QString());

    bool isValid() const;

    const QString workgroup() const;
    void setWorkgroup(const QString &workgroup);

    const QString host() const;
    void setHost(const QString &host);

    const QString share() const;
    void setShare(const QString &share);

    const QString tailPath() const;
    void setTailPath(const QString &tailPath);

    QString toString() const;

private:
    bool m_valid;
    QString m_workgroup;
    QString m_host;
    QString m_share;
    QString m_tailPath;
};

} // namespace FlyFM

#endif // FLYFM_SMBURL_H
