/*

  Explorer Graphic User's Interface Library
  Status Bar

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMSTATUSBAR_H
#define FLYFMSTATUSBAR_H

#include <flyfm/gui_export.h>

#include <QStatusBar>

#include <flyfm/entrylist.h>

namespace FlyFM
{

class EntryDescribeThread;

class FLYFM_GUI_EXPORT StatusBar : public QStatusBar
{
    Q_OBJECT
public:
    StatusBar(QWidget *parent = nullptr);
    ~StatusBar();

    void setFreeSpaceMessage(const QString &msg);
    void setItemCount(int items);
    void setSelectedItemCount(int items);

private:
    QString fullMessage() const;

    QString m_freeSpaceMessage;
    int m_itemCount;
    int m_selectedItemCount;
};

}

#endif // FLYFMSTATUSBAR_H
