#ifndef FLYFM_STORAGEPLACESJOBS_H
#define FLYFM_STORAGEPLACESJOBS_H

#include <QSharedPointer>
#include <QDBusInterface>

#include <flyfm/job.h>
#include <flyfm/storageplace.h>

class QDBusPendingCallWatcher;

namespace FlyFM
{

class StoragePlaceJob : public Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NoInterface, InternalError };
    explicit StoragePlaceJob(QObject *parent = nullptr) : Job(parent) {}

protected slots:
    void callFinishedSlot(QDBusPendingCallWatcher *call);
};

///////////////////////////////////////////////////

class StoragePlaceMountJob : public StoragePlaceJob
{
    Q_OBJECT
public:
    StoragePlaceMountJob(const StoragePlace &storagePlace, const QSharedPointer<QDBusInterface> &interface, QObject *parent = nullptr);

    void start() override;

private:
    StoragePlace m_storagePlace;
    QSharedPointer<QDBusInterface> m_interface;
};

///////////////////////////////////////////////////

class StoragePlaceUnmountJob : public StoragePlaceJob
{
    Q_OBJECT
public:
    StoragePlaceUnmountJob(const StoragePlace &storagePlace, const QSharedPointer<QDBusInterface> &interface, QObject *parent = nullptr);

    void start() override;

private:
    StoragePlace m_storagePlace;
    QSharedPointer<QDBusInterface> m_interface;
};

///////////////////////////////////////////////////

class StoragePlaceEjectJob : public StoragePlaceJob
{
    Q_OBJECT
public:
    StoragePlaceEjectJob(const StoragePlace &storagePlace, const QSharedPointer<QDBusInterface> &interface, QObject *parent = nullptr);

    void start() override;

private:
    StoragePlace m_storagePlace;
    QSharedPointer<QDBusInterface> m_interface;
};

} // namespace FlyFM

#endif // FLYFM_STORAGEPLACESJOBS_H
