/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_THREAD_H
#define FLYFM_THREAD_H

#include <flyfm/core_export.h>

#include <QThread>
#include <QWaitCondition>
#include <QMutex>

namespace FlyFM
{
class FLYFM_CORE_EXPORT Thread : public QThread
{
    Q_OBJECT

public:
    Thread(QObject *parent);
    virtual ~Thread();

    int exitCode() const;
    QString errorString() const;

public slots:

    void suspend();
    void release();

protected:
    void setExitCode(int exitCode);
    void setErrorString(const QString &errorString);

    void waitForSuspend();
    bool checkSuspend();

    int m_exitCode;
    QString m_errorString;
    QWaitCondition m_selfSuspendCondition;
    QMutex m_selfSuspendMutex;
    QMutex m_suspendMutex;
};
}

#endif // FLYFM_THREAD_H
