#ifndef FLYFM_UPDATENETWORKPLACEJOB_H
#define FLYFM_UPDATENETWORKPLACEJOB_H

#include <QString>
#include <QSharedPointer>

#include <flyfm/job.h>
#include <flyfm/entry.h>

namespace FlyFM
{

class Authenticator;

class FLYFM_VFS_EXPORT UpdateNetworkPlaceJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NotSambaEntry, LoginCancelled, NoShareEntry, NotInFuseGroup, InternalError };

    explicit UpdateNetworkPlaceJob(QSharedPointer<Authenticator> authenticator, const Entry &netPlaceEntry, QObject *parent = nullptr);

    void start() override;

    Entry netPlaceEntry() const;

private slots:
    void slotMountURLJobFinished(Job *job);
    void slotNetworkPlaceUpdatedInVFS(const Entry &entry);

private:
    Entry m_netPlaceEntry;
    QSharedPointer<Authenticator> m_authenticator;
    QString m_smbPathTail;
};

} // namespace FlyFM

#endif // FLYFM_UPDATENETWORKPLACEJOB_H
