#ifndef FLYFM_UPDATESMBENTRYJOB_H
#define FLYFM_UPDATESMBENTRYJOB_H

#include <QSharedPointer>

#include <flyfm/job.h>
#include <flyfm/entry.h>

namespace FlyFM
{

class Authenticator;

class FLYFM_VFS_EXPORT UpdateSmbEntryJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NotSambaEntry, LoginCancelled, NoShareEntry, NotInFuseGroup };

    explicit UpdateSmbEntryJob(QSharedPointer<Authenticator> authenticator, const Entry &smbEntry, QObject *parent = nullptr);

    void start() override;

    Entry smbEntry() const;

private slots:
    void updateWorkgroupsFinished();
    void updateWorkgroupFinished();
    void updateHostFinished();

    void checkJobFinished(Job *job);

private:
    Entry m_smbEntry;
    QSharedPointer<Authenticator> m_authenticator;
};

} // namespace FlyFM

#endif // FLYFM_UPDATESMBENTRYJOB_H
