#ifndef FLYFMUSERPROPCAPSWIDGET_H
#define FLYFMUSERPROPCAPSWIDGET_H

#include <sys/types.h>

#include <QWidget>
#include <QMap>

class QListWidgetItem;
class QListWidget;

namespace FlyFM
{
using PluginAccessMap = QMap<QString, bool>;

class UserPropCapsWidget : public QWidget
{
    Q_OBJECT

public:

    UserPropCapsWidget(QWidget *parent);
    virtual ~UserPropCapsWidget();

    void apply();

protected slots:

    void userSelected(QListWidgetItem *, QListWidgetItem *);
    void pluginChanged(QListWidgetItem *);

protected:

    void initialize();
    void refreshPlugins();

    QListWidget *m_userList;
    QListWidget *m_pluginList;

    QMap<uid_t, PluginAccessMap> m_userPluginAccessMap;
};
}

#endif // FLYFMUSERPROPCAPSWIDGET_H
